import 'package:zap_architecture/zap_architecture.dart';
import 'package:zap_server/zap_server.dart';

/// Created by Musa Usman on 18.01.2021
/// Copyright © 2021 Musa Usman. All rights reserved.
///
/// Email: hello@musausman.com
/// Website: musausman.com
/// WhatsApp: +1 307-459-1575

void main() async {
  ExampleServer server = ExampleServer();

  await server.start(portNumber: 8888);

  print(
      "Example Server Started!\nVISIT: ${server.serverAddress}:${server.port}");
}

class ExampleServer extends ZAPServer {
  @override
  Future<void> prepare() async {
    print("Preparing...");
  }

  @override
  Future<void> route(Router router) async {
    router.get(
      "/hello",
      () async => Response.success("Hello"),
    );
    router.get(
      "/world",
      () async => Response.success("World"),
    );
  }

  @override
  Response routeNotFound(String endpoint) => Response.error(
        errorMessage: "Dude, you are a serious dum dum! 404!",
        friendlyErrorMessage:
            "OH MY GAWWWD! Your developer is a dum-dum! Get help!",
      );
}
