import 'dart:io';

class IPAddress {
  static Future<String> get() async {
    List<String> segmentedLines = [];

    if (Platform.isMacOS || Platform.isLinux) {
      ProcessResult raw = await Process.run("ifconfig", []);

      RegExp("inet (addr:)?([0-9]*\.){3}[0-9]*")
          .allMatches(raw.stdout)
          .forEach((match) {
        String matchingString =
            raw.stdout.toString().substring(match.start, match.end);

        matchingString = matchingString.replaceAll("inet", "").trim();

        segmentedLines.add(matchingString);
      });
    } else {
      ProcessResult raw = await Process.run("ipconfig", []);

      RegExp("IPv4 Address. . . . . . . . . . . : (addr:)?([0-9]*\.){3}[0-9]*")
          .allMatches(raw.stdout)
          .forEach((match) {
        String matchingString =
            raw.stdout.toString().substring(match.start, match.end);

        matchingString = matchingString
            .replaceAll("IPv4 Address. . . . . . . . . . . :", "")
            .trim();

        segmentedLines.add(matchingString);
      });
    }

    segmentedLines.remove("127.0.0.1");

    return segmentedLines.first;
  }
}
